import React, { useState, useEffect } from 'react';
import { Modal, Tree, Row, Col, Checkbox } from 'antd';
import Enumerable from 'linq';

const MenuForm = (props) => {
  const [load, setLoad] = useState([]);
  const [checkedKeys, setCheckedKeys] = useState();
  const [indeterminate, setindeterminate] = useState(false);
  const [checkAll, setcheckAll] = useState(false);
  useEffect(async () => {
    var arr = [];
    var filteredArr = []
    Enumerable.from(props.values).forEach(t => {
      if (!t.isParentMenu) {
        arr.push(t.id);
      }
      if (t.id !== null && typeof t.id !== "undefined") {
        filteredArr.push(t);
      }
    });
    setCheckedKeys(arr)
    var data = props.treeData;
    if (getTreeLength(data) === filteredArr.length) {
      setcheckAll(true)
      setindeterminate(false);
    } else {
      setcheckAll(false);
      if (props.values.length == 0) {
        setindeterminate(false);
      } else {
        setindeterminate(true);
      }
    }
    setLoad(data);
  }, [props.modalOpen])
  function getTreeLength(tree) {
    let length = tree.length;
    for (let i = 0; i < tree.length; i++) {
      if (Array.isArray(tree[i].children)) {
        length += getTreeLength(tree[i].children);
      }
    }
    return length;
  }
  const onCheckAllChange = (e) => {
    if (!checkAll) {
      var data = getAllIds(load, []);
      setCheckedKeys(data)
      setcheckAll(true)
      setindeterminate(false);
    } else {
      setCheckedKeys([])
      setcheckAll(false)
      setindeterminate(false);
    }

  };
  function getAllIds(tree, result) {
    for (const i in tree) {
      result.push(tree[i].key);
      if (tree[i].children) {
        getAllIds(tree[i].children, result);
      }
    }
    return result;
  }
  return (
    <Modal
      width={700}
      bodyStyle={{ padding: '32px 40px 48px' }}
      destroyOnClose
      title={'菜单分配'}
      open={props.modalOpen}
      onOk={() => props.onSubmit(checkedKeys)}
      onCancel={() => props.onCancel()}
      maskClosable={false}
    >
      <Row>
        <Col span={8}>
          <Checkbox indeterminate={indeterminate} onChange={onCheckAllChange} checked={checkAll}>
            全选
          </Checkbox>
          <Tree treeData={load}
            onCheck={(keys, e) => {
              if (getTreeLength(props.treeData) == keys.length) {
                setcheckAll(true)
                setindeterminate(false);
              } else {
                setcheckAll(false)
                setindeterminate(true);
              }
              setCheckedKeys(keys);
            }}
            defaultExpandAll={false}
            checkedKeys={checkedKeys}
            checkable />
        </Col>
      </Row>
    </Modal>
  )
};

export default MenuForm;
