import React from 'react';
import { Modal, Form, Input, Button, InputNumber } from 'antd';

const CreateForm = (props) => {

    return (
        <Modal
            title={props.values.id ? '编辑' : '新建'}
            width={640}
            visible={props.goodsClassifyVisible}
            bodyStyle={{ padding: '32px 40px 1px 48px' }}
            footer={null}
            onCancel={() => {
                props.onCancel();
            }}
            maskClosable={false}
            destroyOnClose={true}
        >
            <Form
                labelCol={{ span: 4 }}
                layout="horizontal"
                preserve={false}
                initialValues={props.values}
                onFinish={props.onFinish}
            >
                <Form.Item name="id" hidden={true}>
                    <Input />
                </Form.Item>
                <Form.Item name="name" label="分类名称" rules={[{ required: true, max: 50 }]}>
                    <Input />
                </Form.Item>
                <Form.Item name="remark" label="备注" >
                    <Input />
                </Form.Item>
                <Form.Item name="sort" label="排序" >
                    <InputNumber />
                </Form.Item>
                <Form.Item>
                    <Button htmlType="button" style={{ float: 'right', left: 10 }} onClick={props.onCancel} >
                        取消
                    </Button>
                    <Button disabled={!props.codeList.includes('GoodClassifyUp')} type="primary" htmlType="submit" style={{ float: 'right' }} >
                        保存
                    </Button>
                </Form.Item>
            </Form>
        </Modal>
    );
};

export default CreateForm;