import React, { useRef, useState, useEffect } from 'react';
import { message, Modal, Form, Input, Button, Upload, Select, InputNumber, TreeSelect, Switch, Divider, Space } from 'antd';
import { } from '../service';

const ChooseForm = (props) => {
    const inputRef = useRef();

    return (
        <Modal
            title='以下商品重复，请选择覆盖或跳过'
            width={500}
            visible={props.showChooseForm}
            onCancel={props.onCancel}
            footer={null}
            maskClosable={false}
            destroyOnClose
        >
            <Form
                layout="inline"
                preserve={false}
                form={props.form}
                onFinish={props.onFinish}
            >
                {Array.isArray(props.values) && props.values.map((t, index) => (
                    <div key={index} style={{ marginBottom: '10px', clear: 'both' }}>
                        <div style={{ float: 'left', marginRight: '10px' }}>
                            <Form.Item name={t.goodsName} label="商品名称">
                                <span>{t.goodsName}</span>
                            </Form.Item>
                        </div>
                        <div style={{ float: 'left' }}>
                            <Form.Item
                                name={t.goodsName}
                                label="覆盖或跳过"
                                valuePropName="checked"
                            >
                                <Switch checkedChildren="覆盖" unCheckedChildren="跳过" defaultChecked={true} />
                            </Form.Item>
                        </div>
                    </div>
                ))}
                <Form.Item style={{ textAlign: 'right', marginTop: '10px', float: 'right', width: '100%' }}>
                    <Button htmlType="button" style={{ marginRight: '10px' }} onClick={props.onCancel}>
                        取消
                    </Button>
                    <Button type="primary" htmlType="submit">
                        保存
                    </Button>
                </Form.Item>
            </Form>
        </Modal>
    );
};


export default ChooseForm;