import { PlusOutlined } from '@ant-design/icons';
import { Modal, Button, message, Popconfirm,Transfer } from 'antd';
import React, { useState, useRef, useEffect } from 'react';
import { PageContainer } from '@ant-design/pro-layout';
import ProTable from '@ant-design/pro-table';
import CreateForm from './components/CreateForm';
import {
  GetDeviceInfoPage,
  GetProductList,
  AddDeviceInfo,
  UpdateDeviceInfo,
  DelDeviceInfo,
  GetDeviceType,
  GetDeviceVesion,
  GetStop,
  TechnologyTemplateExport,
  Getgoodslist,
  getdevicegoods,
  editdevicegoodsapi,
  GetDeviceVersions
} from './services';
import { gettree } from '../../org/orgamange/service';
import './index.less';
import publicApi from '@/services/api';

const GoodsTypeManage = () => {
  const [storeType, setStoreType] = useState();
  const [storeTypeArray, setStoreTypeArray] = useState([]);
  const [OrgList, setOrgList] = useState([]);
  const [OrgListArray, setOrgListArray] = useState([]);
  const [dicDataAny, setDicDataAny] = useState([]);
  const [dicData, setDicData] = useState([]);
  const [deviceVersion, setDeviceVersion] = useState([]);
  /** 新建/更新窗口的弹窗 */
  const [createModalVisible, handleModalVisible] = useState(false);
  /** 分布更新窗口的弹窗 */
  const actionRef = useRef();
  const [currentRow, setCurrentRow] = useState();
  const [selectedRowsState, setSelectedRows] = useState([]);
  const [StopData, setStopData] = useState([]);
  const [isModalOpen, setIsModalOpen] = useState(false);
  const [mockData, setMockData] = useState([]);
  const [targetKeys, setTargetKeys] = useState([]);
  const [codeList, setCodeList] = useState([]);

  //初始化数据
  useEffect(() => {
    publicApi.getRoleBasicMenu().then((r) => {
      if (r.data) {
        setCodeList(r.data)
      }
    })
    GetStop().then((t) => {
      setStopData(t.data)
    });

    Getgoodslist().then((item) => {
      var data=item.data;
      const tempMockData = [];
      data.forEach((item)=>{
        tempMockData.push({
          key: item.id,
          title: item.name,
          description: item.name,
        });
      })
      setMockData(tempMockData);
    });

    function initOrgList() {
      gettree().then((r) => {
        inittree(r.data);
        function inittree(datas) {
          for (var i in datas) {
            if (datas[i]['type'] == 2 || datas[i]['type'] == 3) {
              datas[i]['disabled'] = false;
            } else {
              datas[i]['disabled'] = true;
            }
            if (datas[i].children) {
              inittree(datas[i].children);
            }
          }
        }
        setOrgList(r.data);
        let list = {};
        formateData(r.data);
        function formateData(datas) {
          for (var i in datas) {
            list[datas[i]['disabled']] = true;
            list[datas[i]['value']] = { text: datas[i]['title'] };
            if (datas[i].children) {
              formateData(datas[i].children);
            }
          }
        }
        setOrgListArray(list);
      });
    }
    initOrgList();
    initDeviceType();
    function intDicData() {
      GetProductList().then((r) => {
        var arr = r.data;
        let data = {};
        if (r.succeeded) {
          var list = [];
          arr.forEach((item) => {
            data[item.name] = { text: item.name };
            list.push({
              id: item.id,
              label: item.name,
              text: item.name,
            });
          });
          setDicDataAny(data);
          setDicData(list);
        }
      });
    }
    intDicData();
    initDeviceVersionList();
  }, []);
  const initDeviceType = () => {
    GetDeviceType().then((data) => {
      let list = {};
      let list2 = [];
      data.data.forEach((item) => {
        list2.push({
          label: item.name,
          text: item.name,
          value: item.id,
        });
        list[item.id] = { text: item.name };
      });
      setStoreTypeArray(list2);
      setStoreType(list);
    });
  };
  const initDeviceVersionList = async()=>{
    const response = await GetDeviceVersions();
    if (response.statusCode == 200) {
      setDeviceVersion(response.data);
    } else {
      message.error('获取设备版本失败');
    }
  }
  const initDeviceVersion = async (record) => {
    const response = await GetDeviceVesion(record?.productId);
    if (response.statusCode == 200) {
      setDeviceVersion(response.data);
    } else {
      message.error('获取设备版本失败');
    }
  };
  const BatchDeletion = () => {
    return (
      selectedRowsState?.length > 0 &&
      (
        <Popconfirm
          title="确认删除吗?"
          onConfirm={onClickdele}
          okText="确定"
          cancelText="取消"
        >
          <Button type="primary">批量删除</Button>
        </Popconfirm>
      ))
  }
  const onClickdele = () => {
    handleRemove(selectedRowsState);
    setSelectedRows([]);
    actionRef.current?.reloadAndRest?.();
  }
  /**
* 删除节点
*
* @param selectedRows
*/
  const handleRemove = async (selectedRows) => {
    if (!selectedRows) return true;
    await DelDeviceInfo(selectedRows.map((row) => row.id)).then((r) => {
      if (r.data) {
        message.success('删除成功');
        actionRef.current.reload();
      } else {
        message.error('删除失败，请重试');
      }
    });
    return true;
  };
  /** 国际化配置 */

  const columns = [
    {
      title: '主键',
      dataIndex: 'id',
      hideInSearch: true,
      hideInTable: true,
      tip: '规则名称是唯一的 key',
    },
    {
      title: '设备名称',
      dataIndex: 'deviceName',
      valueType: 'textarea',
    },
    {
      title: '产品',
      dataIndex: 'productName',
      valueEnum: dicDataAny,
      hideInSearch: true,
    },
    {
      title: '产品版本',
      dataIndex: 'productVersionName',
      search: false,
    },
    {
      title: '所属场景',
      dataIndex: 'stopName',
      search: false,

    },
    {
      title: '地址',
      dataIndex: 'address',
      search: false,
    },
    {
      title: '设备标签',
      dataIndex: 'deviceTypeId',
      valueEnum: storeType,
    },
    {
      title: '设备唯一key',
      dataIndex: 'autoKey',
      search: false,
    },
    {
      title: '操作',
      dataIndex: 'option',
      valueType: 'option',
      fixed: 'right',
      width: 300,
      render: (_, record) => [
        <a
          key="update"
          onClick={() => {
            initDeviceVersion(record);
            handleModalVisible(true);
            setCurrentRow(record);
          }}
        >
          更新
        </a>,
        codeList.includes('DeviceDel') && (
        <Popconfirm
          type="primary"
          key="primary"
          title="确认删除吗？"
          okText="是"
          cancelText="否"
          onConfirm={async () => {
            await DelDeviceInfo([record.id]).then((r) => {
              if (r.data) {
                message.success('删除成功');
                actionRef.current.reload();
              } else {
                message.error(r.errors);
              }

            });
          }}
        >
          <a href="#">删除</a>
        </Popconfirm>),
        codeList.includes('DeviceDown') && (
        <a
          key="add"
          onClick={async () => {
            const response = await TechnologyTemplateExport(record.id);
            if (response == '') {
              message.error('当前模板不存在！');
              return;
            }
            const link = document.createElement('a');
            link.href = response;
            link.click();
          }}
        >
          导出工艺模版
        </a>),
      ],
    },
  ];

  //添加
  const handleAdd = async (fields) => {
    await AddDeviceInfo(JSON.stringify(fields)).then((r) => {
      if (r.succeeded) {
        message.success('添加成功');
        handleModalVisible(false);
        actionRef.current.reload();
      } else {
        message.error(r.errors)
        return false;
      }
    });

  };
  //修改
  const handleUpdate = async (fields) => {
    await UpdateDeviceInfo(JSON.stringify(fields)).then((r) => {
      if (r.succeeded) {
        message.success('更新成功');
        handleModalVisible(false);
        actionRef.current.reload();
      } else {
        message.error(r.errors)
        return false;
      }
    });

  };

  //修改
  const editdevicegoods = async () => {

    const tempMockData = [];

    targetKeys.forEach(function (item, index, array) {
      tempMockData.push({
        "goodsId" : item,
        "goodsName":""
        });
    })
    var data={
      "deviceId": currentRow.id,
      "goodsList": tempMockData,
      "autoKey":currentRow.autoKey
    }
     editdevicegoodsapi(data).then((r) => {
      if (r.succeeded) {
        message.success('编辑成功');
        handleModalVisible(false);
        actionRef.current.reload();
      } else {
        message.error(r.errors)
        return false;
      }
    });
    setIsModalOpen(false);
  };

  const handleChange = (newTargetKeys) => {
    setTargetKeys(newTargetKeys);
  };

  return (
    <PageContainer host header={{
      title: '',
      breadcrumb: {},
    }}>
      <ProTable
        headerTitle="设备信息"
        actionRef={actionRef}
        rowKey="id"
        pagination={{ defaultPageSize: 10 }}
        search={{
          labelWidth: 120,
        }}
        scroll={{ x: 2000 }}
        toolBarRender={() => [
          codeList.includes('DeviceAdd') && (
          <Button
            type="primary"
            key="primary"
            onClick={() => {
              handleModalVisible(true);
            }}
          >
            <PlusOutlined /> 新建
          </Button>),
        codeList.includes('DeviceDel') && (
          <BatchDeletion />),
        ]}
        request={async (params) => {
          var data = [];
          var total = 0;
          await GetDeviceInfoPage(params).then((r) => {
            data = r.data.data;
            total = r.data.total;
          });
          return {
            data: data,
            success: true,
            total: total,
          };
        }}
        columns={columns}
        rowSelection={{
          onChange: (_, selectedRows) => {
            setSelectedRows(selectedRows);
          },
        }}
      />
      <CreateForm
        codeList={codeList}
        storeType={storeTypeArray}
        OrgData={OrgList}
        dicData={dicData}
        initDeviceType={initDeviceType}
        onFinish={async (value) => {
          if (value.id) {
            handleUpdate(value);
          } else {
            handleAdd(value);
          }
        }}
        onCancel={() => {
          handleModalVisible(false);
          setCurrentRow(undefined);
        }}
        createModalVisible={createModalVisible}
        deviceVersions={deviceVersion}
        values={currentRow || {}}
        StopData={StopData}
      />

      <Modal width={600} title="选择商品" open={isModalOpen} onOk={() => {editdevicegoods() }}    onCancel={() => { setIsModalOpen(false); }}>
        <Transfer
         className="tree-transfer"
          dataSource={mockData}
          targetKeys={targetKeys}
          onChange={handleChange}
          onSearch={()=>{}}
          render={(item) => item.title}
        />
      </Modal>

    </PageContainer>
  );
};

export default GoodsTypeManage;
