import React, { useState, useEffect } from 'react';
import { message, Modal, Descriptions,Table } from 'antd';
import ProTable from '@ant-design/pro-table';
import ProDescriptions from '@ant-design/pro-descriptions';
import api from './service';
import { FrownTwoTone } from '@ant-design/icons';

let defaultData = {};
const OrderflowDetail = (props) => {
  const { createModalVisible, onCancel } = props;
  const [orderInfo, setOrderInfo] = useState([]);
  return (
    <Modal
      title={'订单详情'}
      width={1000}
      visible={props.createModalVisible}
      bodyStyle={{ padding: '32px 40px 48px' }}
      footer={null}
      destroyOnClose
      onCancel={() => onCancel()}
      maskClosable={false}
    >
      {/* <ProDescriptions title="订单信息"
        request={async () => {
          defaultData = await api.GetOrderDetails({ id: props.values.id });
          setOrderInfo(defaultData);
          return Promise.resolve({
            success: true,
            data: defaultData,
          });
        }}
        columns={[
          {
            title: '会员姓名',
            key: 'customer_Name',
            dataIndex: 'customer_Name',
          },
          {
            title: '手机号',
            key: 'customer_Tel',
            dataIndex: 'customer_Tel',
          },
          {
            title: '订单流水',
            key: 'order_Number',
            dataIndex: 'order_Number',
          },
          {
            title: '订单号',
            key: 'transaction_ID',
            dataIndex: 'transaction_ID',
          },
          {
            title: '交易单号',
            key: 'trade_no',
            dataIndex: 'trade_no',
          },
          {
            title: '排队号',
            key: 'order_SortID',
            dataIndex: 'order_SortID',
          },
          {
            title: '折扣',
            key: 'discount',
            dataIndex: 'discount',
          },
          {
            title: '实付金额',
            dataIndex: 'order_RealMoney',
            valueType: 'money',
            fieldProps: {
              moneySymbol: '¥',
            },
          },
          {
            title: '应付金额',
            dataIndex: 'order_OriginalMoney',
            valueType: 'money',
            fieldProps: {
              moneySymbol: '¥',
            },
          },
          {
            title: '实付金额(退)',
            dataIndex: 'refundRealMoney',
            valueType: 'money',
            fieldProps: {
              moneySymbol: '¥',
            },
          },
          {
            title: '应付金额(退)',
            dataIndex: 'refundOriginalMoney',
            valueType: 'money',
            fieldProps: {
              moneySymbol: '¥',
            },
          },

          {
            title: '数量',
            dataIndex: 'order_Count',
            hideInSearch: true,
          },
          {
            title: '支付方式',
            dataIndex: 'payMode',
            key: 'payMode',
          },

          {
            title: '订单状态',
            dataIndex: 'order_Status',
            key: 'order_Status',
          },
          {
            title: '消费金额',
            dataIndex: 'recharge',
            key: 'recharge',
          },
          {
            title: '消费赠送金额',
            dataIndex: 'rechargeBalance',
            key: 'rechargeBalance',
          },
        ]}
      ></ProDescriptions> */}
      <h3 style={{fontWeight:'bold',fontSize:16,marginTop:30}}>商品列表</h3>
      <Table 
        rowKey="id"
        dataSource={props.values.orderdetail}
        // request={async () => {
        //   defaultData = props.values.orderdetail;//await api.GetOrderDetails({ id: props.values.id });
        //   return {
        //     data: defaultData,
        //     success: true,
        //   };
        // }}
        expandable={{
          expandedRowRender: (record) => (
            <Table 
            columns={[
              {
                title: '属性名称',
                key: 'attributeName',
                dataIndex: 'attributeName',
              },
              {
                title: '数量',
                key: 'count',
                dataIndex: 'count',
              },
              {
                title: '价格',
                key: 'price',
                dataIndex: 'price',
              },
            ]} dataSource={record.goodsAttr} pagination={false}></Table>
          ),  defaultExpandedRowKeys: ['0'],
        }}
        columns={[
          {
            title: '商品名称',
            key: 'goodsName',
            dataIndex: 'goodsName',
          },
          {
            title: '商品编号',
            key: 'goodsNumber',
            dataIndex: 'goodsNumber',
          },
          // {
          //   title: '操作',
          //   dataIndex: 'option',
          //   valueType: 'option',
          //   render: (_, record) => [
          //     <a
          //       key="config"
          //       onClick={() => {
          //         api.printsmallticket({ "orderId": props.values.id, "subOrderId": record.id })
          //           .then(re => {
          //             debugger
          //             if (re.data) {
          //               message.success('打印成功');
          //             } else {
          //               message.error('打印失败');
          //             }

          //           })

          //       }} >
          //       打印小票
          //     </a>,
          //   ],
          // },

        ]}
        toolBarRender={false}
        search={false}
        pagination={false}
      />
      {/* <Descriptions title="优惠券">
        {defaultData?.paperCoupons?.map(item => {
          return (
            <>
            <Descriptions.Item label="平台">{item.platformName }</Descriptions.Item>
            <Descriptions.Item label="优惠券">{item.name}</Descriptions.Item>
            <Descriptions.Item label="优惠金额">{item.amount}</Descriptions.Item>
            </>
          );
        })}

      </Descriptions>
      <Descriptions 
       column={5}
      title="抵扣券">
        {defaultData?.goodsCoupons?.map(item => {
          return (
            <>
            <Descriptions.Item label="平台">{item.platformName }</Descriptions.Item>
            <Descriptions.Item label="抵扣券">{item.name}</Descriptions.Item>
            <Descriptions.Item label="商品">{item.goodsName}</Descriptions.Item>
            <Descriptions.Item label="商品原价">{item.goodsAmount}</Descriptions.Item>
            <Descriptions.Item label="平台售价">{item.platformAmount}</Descriptions.Item>
            </>
          );
        })}

      </Descriptions> */}
    </Modal>
  );
};

export default OrderflowDetail;
