import { request } from 'umi';
import { getDataBaseUrl, GetkitchbaseUrl } from '@/global_data';
import moment from 'moment';
export default {
  placeOrder(data) {
    return request(GetkitchbaseUrl() + `/api/orderInfo/placeOrder`, {
      method: 'POST',
      data: data
    });
  },
  getOrderlist(pageindex = 0, status = 0, storeName, deviceName) {
    var jsondata = {
      "pageSize": 6,
      "pageIndex": pageindex,
      "status": status,
      "storeName": storeName,
      "deviceName": deviceName,
      "startTime": moment().startOf('day').format('YYYY-MM-DD HH:mm:ss'),
      "endTime": moment().endOf('day').format('YYYY-MM-DD HH:mm:ss'),
    }
    return request(GetkitchbaseUrl() + `/api/orderInfo/getOrderInfoPage`, {
      method: 'POST',
      data: jsondata
    });
  },
  appOrderCount(storeName, deviceName) {
    return request(GetkitchbaseUrl() + `/api/orderInfo/getTodayOrderCount?storeName=${storeName}&deviceName=${deviceName}`, {
      method: 'GET'
    });
  },
  getStoreDevice(autoKey) {
    return request(getDataBaseUrl() + `/api/device/getDeviceInfoByDeviceId?autoKey=${autoKey}`, {
      method: 'GET'
    });
  },
  getDeviceGoodsList(autoKey) {
    return request(getDataBaseUrl() + `/api/goods/GetGoodsClassifyByIds?autoKey=${autoKey}`, {
      method: 'GET'
    });
  },
  getDeviceGoodsAttrList(id) {
    return request(getDataBaseUrl() + `/api/goodsattribute/getbygoodsidattribute?id=${id}`, {
      method: 'GET'
    });
  },
  getHaveTechnology(goodId, attrId) {
    return request(getDataBaseUrl() + `/api/goodsattribute/getHaveTechnology?goodId=${goodId}&attrId=${attrId}`, {
      method: 'GET'
    });
  },
}